/* -*- Mode: java; tab-width: 8; c-basic-offset: 4 -*-
 * Copyright  1997, 1998 Netscape Communications Corporation, All Rights Reserved.
 */

package com.netscape.javascript.CORBA;

import com.netscape.javascript.*;
import org.omg.CORBA.TCKind;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.Any;
import org.omg.CORBA.portable.*;
import org.omg.CORBA.CompletionStatus;

/**
 * This class reflects CORBA SystemException into the JS
 * environment.
 *
 * @author Ruslan Belkin
 */

public class   SystemException   extends ScriptableObject {

    public SystemException (String name, String reason, CompletionStatus completed)
    {
        values = new Object [4];
        
        values[0] = new String (name);
        values[1] = new String (reason);
        values[2] = new Integer (completed.value ());
        values[3] = new Integer(0);
    }

    public String getClassName ()
    {
        return "SystemException";
    }

    public SystemException (org.omg.CORBA.SystemException se)
    {
        values = new Object [4];
        
        values[0] = se.getClass ().getName ();
        values[1] = se.getMessage ();
        values[2] = new Integer (se.completed.value ());
        values[3] = new Integer(0);
    }

    public Object getDefaultValue(Class hint)
    {
	    if (hint == null ||
            hint == String.class)   return values[0];

        if (hint == Integer.class)  return values[2];

    	return this;
    }

    public boolean has (String id, int index, Scriptable start)
    {
        if (id != null)
            for (int i = 0; i < fields.length; i++)
                if (id.equals (fields[i]))
                return true;

        return false;
    }

    public Object get (String id, int index, Scriptable start)
    {
        if (id != null)
            for (int i = 0; i < fields.length; i++)
                if (id.equals (fields[i]))
                    return values[i];

        return Scriptable.NOT_FOUND;
    }

    Object values[];

    static  String fields [] = { "name", "reason", "completed", "minor" };
